----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:27:26 11/05/2007 
-- Design Name: 
-- Module Name:    MAIN - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MAIN is
    Port ( 
           RSTN : in STD_Logic;
           MCLK : in  STD_LOGIC;
           RXFN : in  STD_LOGIC;
           FD : in  STD_LOGIC_VECTOR (7 downto 0);
           RDN : out  STD_LOGIC;
           LRCK : out  STD_LOGIC;
           SCK : out  STD_LOGIC;
           SD : out  STD_LOGIC);
end MAIN;

architecture Behavioral of MAIN is

-- Internal Signal
signal I2SState : STD_LOGIC_VECTOR (7 downto 0);
signal RDNI : STD_LOGIC;
signal LL : STD_LOGIC_VECTOR (7 downto 0);
signal LH : STD_LOGIC_VECTOR (7 downto 0);
signal RL : STD_LOGIC_VECTOR (7 downto 0);
signal RH : STD_LOGIC_VECTOR (7 downto 0);
signal SDI : STD_LOGIC;

signal RXFNI : STD_LOGIC;
signal RXFNI2 : STD_LOGIC;

signal LRCK2 : STD_LOGIC;
signal SD2 : STD_Logic;
signal SCK2 : STD_Logic;

begin
	process (MCLK, RXFN) begin
		if rising_edge(MCLK) then
			RXFNI <= RXFN;
		end if;
	end process;

	process (MCLK, RSTN, RXFNI, FD) begin
		if (RSTN = '0') then
			I2SState <= "00000000";
			SDI <= '0';
			RDNI <= '1';
			RXFNI2 <= '1';
			LL <= "00000000";
			LH <= "00000000";
			RL <= "00000000";
			RH <= "00000000";
		elsif rising_edge(MCLK) then
			I2SState <= I2SState + '1';
	
			case I2SState(7 downto 2) is
				when "000001" =>	--L02
									SDI <= LH(7);
									RDNI <= '1';
									RXFNI2 <= RXFNI;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "000010" =>	--L03
									SDI <= LH(6);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "000011" =>	--L04
									SDI <= LH(5);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "000100" =>	--L05
									SDI <= LH(4);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "000101" =>	--L06
									SDI <= LH(3);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "000110" =>	--L07
									SDI <= LH(2);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "000111" =>	--L08
									SDI <= LH(1);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001000" =>	--L09
									SDI <= LH(0);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001001" =>	--L10
									SDI <= LL(7);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001010" =>	--L11
									SDI <= LL(6);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001011" =>	--L12
									SDI <= LL(5);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001100" =>	--L13
									SDI <= LL(4);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001101" =>	--L14
									SDI <= LL(3);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001110" =>	--L15
									SDI <= LL(2);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "001111" =>	--L16
									SDI <= LL(1);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "010000" =>	--L17
									SDI <= LL(0);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "100001" =>	--R34
									SDI <= RH(7);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "100010" =>	--R35
									SDI <= RH(6);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "100011" =>	--R36
									SDI <= RH(5);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "100100" =>	--R37
									SDI <= RH(4);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "100101" =>	--R38
									SDI <= RH(3);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "100110" =>	--R39
									SDI <= RH(2);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "100111" =>	--R40
									SDI <= RH(1);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101000" =>	--R41
									SDI <= RH(0);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101001" =>	--R42
									SDI <= RL(7);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101010" =>	--R43
									SDI <= RL(6);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101011" =>	--R44
									SDI <= RL(5);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101100" =>	--R45
									SDI <= RL(4);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101101" =>	--R46
									SDI <= RL(3);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101110" =>	--R47
									SDI <= RL(2);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "101111" =>	--R48
									SDI <= RL(1);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "110000" =>	--R49
									SDI <= RL(0);
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "110001" =>	--R50
									SDI <= '0';
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "110010" =>	--R51
									SDI <= '0';
									RDNI <= '1';
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "110011" =>	--R52
									SDI <= '0';
									RDNI <= RXFNI2;
									RXFNI2 <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "110100" =>	--R53
									SDI <= '0';
									RDNI <= '1';
									if (RXFNI2 = '0') then
										LL <= FD;
									else
										LL <= "00000000";
									end if;
									LH <= LH;RL <= RL;RH <= RH;
				when "110101" =>	--R54
									SDI <= '0';
									RDNI <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "110110" =>	--R55
									SDI <= '0';
									RDNI <= '1';
									if (RXFNI2 = '0') then
										LH <= FD;
									else
										LH <= "00000000";
									end if;
									LL <= LL;RL <= RL;RH <= RH;
				when "110111" =>	--R56
									SDI <= '0';
									RDNI <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "111000" =>	--R57
									SDI <= '0';
									RDNI <= '1';
									if (RXFNI2 = '0') then
										RL <= FD;
									else
										RL <= "00000000";
									end if;
									LL <= LL;LH <= LH;RH <= RH;
				when "111001" =>	--R58
									SDI <= '0';
									RDNI <= RXFNI2;
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
				when "111010" =>	--R59
									SDI <= '0';
									RDNI <= '1';
									if (RXFNI2 = '0') then
										RH <= FD;
									else
										RH <= "00000000";
									end if;
									LL <= LL;LH <= LH;RL <= RL;
				when Others =>	
									SDI <= '0';
									RDNI <= '1';
									LL <= LL;LH <= LH;RL <= RL;RH <= RH;
			end case;
		end if;
	end process;

	process (MCLK, I2SState, SDI) begin
		if rising_edge(MCLK) then
			LRCK2 <= I2SState(7);
			SCK2 <= I2SState(1);
			SD2 <= SDI;
		end if;
	end process;

	LRCK <= LRCK2;
	SCK <= SCK2;
	SD <= SD2;
	RDN <= RDNI;

end Behavioral;

